﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace ScheduleViewTest
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new Model();
        }
    }

    public class TimeRulerItemStyleSelector : OrientedTimeRulerItemStyleSelector
    {
        public Style MinorTickLineStyle { get; set; }
        public Style MajorTickLineStyle { get; set; }

        public override Style SelectStyle(object item, DependencyObject container, ViewDefinitionBase activeViewDeifinition)
        {
            if (container is TimeRulerLine)
            {
                TickData tick = item as TickData;
                if (tick.Type == TickType.Major)
                    return MajorTickLineStyle;

                return MinorTickLineStyle;
            }
            return base.SelectStyle(item, container, activeViewDeifinition);
        }
    }

    public class OrderStateForegroundConverter : IValueConverter
    {
        public static IEnumerable<KeyValuePair<string, SolidColorBrush>> StateEnum
        {
            get
            {
                var q = OrderStateColorsDict;
                return q;
            }
        }

        private static readonly Dictionary<string, SolidColorBrush> OrderStateColorsDict = new Dictionary<string, SolidColorBrush>
        {
            {"Rezervováno", new SolidColorBrush( Colors.Red )},
            {"Potvrzeno", new SolidColorBrush( Colors.Blue )},
            {"Objednáno", new SolidColorBrush( Colors.Cyan ) },
            {"Odbaveno", new SolidColorBrush( Colors.Magenta ) },
            {"Připraveno k fakturaci", new SolidColorBrush( Colors.Orange ) },
            {"Fakturováno", new SolidColorBrush( Colors.Yellow ) },
            {"Zaplaceno", new SolidColorBrush( Colors.Green ) },
            {"Interní", new SolidColorBrush( Colors.Gray ) },
            {"Storno", new SolidColorBrush( Colors.Purple ) },
            {"Poptáno", new SolidColorBrush( Colors.AliceBlue ) } // light green
        };

        // to ui
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var state = (string)value;
            if (state == null) return null;

            return OrderStateColorsDict[state];
        }
        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }
    }
}
